<?php
//
// +--------------------------------------------------------------------+
// | PHP version 4                                                      |
// +--------------------------------------------------------------------+
// | Copyright (c) 2005 The Moony Project                               |
// +--------------------------------------------------------------------+
// | This source file is subject to version 3.00 of the PHP License,    |
// | that is available at http://www.php.net/license/3_0.txt.           |
// | If you did not receive a copy of the PHP license and are unable to |
// | obtain it through the world-wide-web, please send a note to        |
// | license@php.net so we can mail you a copy immediately.             |
// +--------------------------------------------------------------------+
// | Authors: YAMAOKA Hiroyuki <yamaoka@catwalker.jp>                   |
// +--------------------------------------------------------------------+
//

/**
 * SmartyѤơ
 * ƥץ졼ȤؤͤȲɽԤΥ饹Ǥ
 * 
 * @access public
 * @package moony.core
 */
class Moony_View {

    /** @var object Smarty饹Υ󥹥 */
    var $_smarty;

    /** @var string ƥץ졼ȥե̾ */
    var $_template;

    /** @var array ƥץ졼Ȥꤹѥ᡼ */
    var $_items = array();

    /** @var bool ܤ̵̵ͭ */
    var $_disabled = false;

    /**
     * 󥹥ȥ饯Ǥ
     * SmartyνԤޤ
     * 
     * @access public
     */
    function Moony_View() {

        $this->_smarty =& new Smarty();

        $this->_smarty->template_dir = MOONY_SMARTY_TEMPLATE_DIR;
        $this->_smarty->compile_dir = MOONY_SMARTY_COMPILE_DIR;
        $this->_smarty->cache_dir = MOONY_SMARTY_CACHE_DIR;
        $this->_smarty->compile_check = MOONY_SMARTY_COMPILE_CHECK;
    }

    /**
     * ƥץ졼Ȥꤹѥ᡼ꤷޤ
     * 
     * @access public
     * @param string $key ѥ᡼
     * @param mixed $value ѥ᡼
     */
    function assign($key, $value) {
        $this->_items[$key] = $value;
    }

    /**
     * ƥץ졼ȥե̾Τꤷޤ
     *
     * @access public
     * @param string $template ƥץ졼ȥե̾
     */
    function setTemplate($template) {
        $this->_template = $template;
    }

    /**
     * ƥץ졼ɽԤޤ
     * 
     * @access public
     */
    function display() {

        // ¸ߥå
        $file = $this->_smarty->template_dir . DIRECTORY_SEPARATOR . $this->_template;
        if (!file_exists($file)) {
            header('HTTP/1.0 404 Not Found');
            exit;
        }

        foreach ($this->_items as $key => $value) {
            $this->_smarty->assign($key, $value);
        }

        $this->_smarty->display($this->_template);
    }

    /**
     * ƥץ졼ȤΥѥ̤򥭥å夹뤳Ȥޤ
     *
     * @access public
     * @param int $lifetime å¸֡ñ̡ǥեȤ3600á
     */
    function cache($lifetime = 3600) {
        $this->_smarty->caching = 2;
        $this->_smarty->cache_lifetime = $lifetime;
    }

    /**
     * ƥץ졼ȤΥѥ̤
     * å夵Ƥ뤫ɤĴ٤ޤ
     * Υ᥽åɤ¹ԤƱ̾Υƥץ졼ȤѤϡ
     * ̵˥å夵ޤ
     *
     * @access public
     * @return å夵Ƥ<code>true</code>
     */
    function isCached() {
        $this->_smarty->caching = true;
        return $this->_smarty->is_cached($this->_template);
    }

    /**
     * ܤ̵ޤ
     *
     * @access public
     */
    function disable() {
        $this->_disabled = true;
    }

    /**
     * ܤ̵Ƥ뤫ɤĴ٤ޤ
     *
     * @access public
     * @return ̵Ƥ<code>true</code>
     */
    function isDisabled() {
        return $this->_disabled;
    }
}
?>